<?php
include('../inc/db.php');

$Hostname = $Config['Database']['Host'];
$Username = $Config['Database']['User'];
$Password = $Config['Database']['Password'];
$Database = $Config['Mangos']['RealmList'][1]['DatabaseMangos']; // must contains characters table
$RealmHostname = $Hostname;
$RealmUsername = $Username;
$RealmPassword = $Password;
$RealmDatabase = $Config['Mangos']['DatabaseRealmd'];  // must contains zone_coordinates and accounts table
$CharactersDatabase = $Config['Mangos']['RealmList'][1]['DatabaseCharacters'];  // must contains zone_coordinates and accounts table
$EmuVersion = $Config['Mangos']['ClientVersion'];
$Owner = $Config['Web']['Admin'];
$ServerName = $Config['Web']['Title'];
$DatabaseEncoding = 'utf8';

$Output = WoWEmuStat();
Header('Content-Type: text/xml');
Header('Content-Length: '.strlen($Output));
echo($Output);

function WoWEmuStat()
{
  global $Hostname, $Username, $Password, $Database, $EmuVersion, $Owner, $ServerName, $realm_db, $DatabaseEncoding,
  $RealmHostname, $RealmUsername, $RealmPassword, $RealmDatabase, $CharactersDatabase;
   
  $Result = 
'<?xml version="1.0" encoding="UTF-8"'."?>\r\n".
'<?xml-stylesheet type="text/xsl" href="stat.xsl"'."?>\r\n".
"  <stats>\r\n".
"    <server>\r\n".
"      <version>".$EmuVersion."</version>\r\n".
"      <owner>".$Owner."</owner>\r\n".
"      <servername>".$ServerName."</servername>\r\n".
"      <uptime>0 weeks 1 days 0 hours 0 mins</uptime>\r\n".
"    </server>\r\n".
"    <serverload>\r\n".
"      <network>\r\n".
"        <configsleep>200</configsleep>\r\n".
"        <loops>0</loops>\r\n".
"        <totaltime>0</totaltime>\r\n".
"        <load>0.00%</load>\r\n".
"      </network>\r\n".
"      <world>\r\n".
"        <configsleep>600</configsleep>\r\n".
"        <loops>95222</loops>\r\n".
"        <totaltime>7594525</totaltime>\r\n".
"        <load>1.50%</load>\r\n".
"      </world>\r\n".
"    </serverload>\r\n".
"    <players>\r\n";

  $realm_db = mysql_connect($RealmHostname, $RealmUsername, $RealmPassword);
  mysql_select_db($RealmDatabase, $realm_db);
  $db_result = mysql_query("SET NAMES $DatabaseEncoding", $realm_db);

  $mangos_db = mysql_connect($Hostname, $Username, $Password, TRUE);
  mysql_select_db($Database, $mangos_db);
  $db_result = mysql_query("SET NAMES $DatabaseEncoding", $mangos_db);
  
  $characters_db = mysql_connect($RealmHostname, $RealmUsername, $RealmPassword);
  mysql_select_db($CharactersDatabase, $characters_db);
  $db_result = mysql_query("SET NAMES $DatabaseEncoding", $characters_db);

  $db_result = mysql_query("SELECT * FROM `characters` WHERE `online`='1' ORDER BY `name`", $characters_db);
  while($result = mysql_fetch_array($db_result))
  {
    // Get GM level by character
    $db_result2 = mysql_query("SELECT gmlevel FROM `account` WHERE `id`='".$result['account']."'", $realm_db);
    //echo("SELECT `gmlevel` FROM `account` WHERE `id`='".$result['account']."'");
    $result2 = mysql_fetch_array($db_result2);
    
    $char_data = explode(' ',$result['data']);
    $Result .= "      <player>\r\n".
    "        <name>".$result['name']."</name>\r\n".
    "        <race>".$result['race']."</race>\r\n".
    "        <class>".$result['class']."</class>\r\n".
    "        <level>".$char_data[53]."</level>\r\n".
    "        <map>".$result['map']."</map>\r\n".
    "        <zone>".get_zone_name($result['map'], $result['position_x'], $result['position_y'])."</zone>\r\n".
    "        <ping>10</ping>\r\n".
    "        <plevel>".$result2['gmlevel']."</plevel>\r\n".
    "        <ip>178.12.14.2</ip>\r\n".
    "      </player>\r\n";
  }
  $Result .= "    </players>\r\n".
   "  </stats>\r\n";
   return($Result);
}

function get_zone_name($mapid, $x, $y)
{
  global $realm_db;
  $query = mysql_query("SELECT * FROM `zone_coordinates` ORDER BY `priory`", $realm_db);
  $zmap = 0;
  while($result = mysql_fetch_array($query))
  {
    if ($result['map']==$mapid AND $result['y_min'] < $x  AND $result['y_max'] > $x AND $result['x_max'] < $y  AND $result['x_min'] > $y) $zmap=$result['zone_id'];
  }
  return $zmap;
} 

?>
